Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1055393 - Review Request: ocaml-biniou - Safe and fast binary data format
Summary: Review Request: ocaml-biniou - Safe and fast binary data format
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jerry James
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1055391
Blocks: 1055396
TreeView+ depends on / blocked
 
Reported: 2014-01-20 07:28 UTC by Michel Alexandre Salim
Modified: 2014-02-06 03:51 UTC (History)
2 users (show)

Fixed In Version: ocaml-biniou-1.0.9-2.fc19
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-02-06 03:48:25 UTC
loganjerry: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Michel Alexandre Salim 2014-01-20 07:28:38 UTC
Spec URL: http://salimma.fedorapeople.org/specs/ocaml/ocaml-biniou.spec
SRPM URL: http://salimma.fedorapeople.org/specs/ocaml/ocaml-biniou-1.0.9-1.fc20.src.rpm
Description: 
Biniou (pronounced "be new") is a binary data format designed for
speed, safety, ease of use and backward compatibility as protocols
evolve. Biniou is vastly equivalent to JSON in terms of functionality
but allows implementations several times faster (4 times faster than
yojson), with 25-35% space savings.

Biniou data can be decoded into human-readable form without knowledge
of type definitions except for field and variant names which are
represented by 31-bit hashes. A program named bdump is provided for
routine visualization of biniou data files.

The program atdgen can be used to derive OCaml-Biniou serializers and
deserializers from type definitions.
Fedora Account System Username: salimma

Comment 1 Jerry James 2014-01-22 20:52:06 UTC
I will take this review.  Can you review cvc4 for me (bug 1029227)?  It's kind of a big hairy package, so I'll review a couple of yours in exchange, starting with this one.  If it is too big and hairy for you, let me know and I'll hunt down another victim, er, volunteer.

Comment 2 Jerry James 2014-01-22 20:59:26 UTC
The first nine issues are repeats from the ocaml-easy-format review, because
they apply to this package as well:

1) Remove the internal dependency generator workarounds.

2) Build a usable -debuginfo package on platforms that generate binary code.

3) The build requires ocaml-findlib only, not ocaml-findlib-devel.

4) Add ExclusiveArch: %{ocaml_arches} to the spec file.

5) Add %{?_isa} to the -devel dependency on the main package.

6) Remove rm -rf $RPM_BUILD_ROOT from the top of %install.

7) Move %define libname down farther (between Summary and License?) and make
   it %global instead.  Oh, and here's a trick that lets you invoke 1
   subprocess instead of two:

   %global libname %(sed -e 's/^ocaml-//' <<< %{name})

8) If possible, avoid building the bytecode version on platforms that can
   build the binary version; in this case, I see this in the build log after
   building the binary version:

   + make opt
   make: Nothing to be done for `opt'.

   because the default target builds both the bytecode and binary versions.

9) Consider adding a %check script; "make test" appears to work for me.

10) The description mentions a binary "atdgen", but there is no such binary in
    any of the binary RPMs.

11) I'm concerned about the binary named "bdump".  First, that's a pretty
    generic name.  It doesn't collide with anything currently in Fedora, but
    I'm concerned that it may in the future.  Also, I'm not certain that bdump
    and the libraries should both go into the main package.  Programs that
    link against the library probably won't need bdump, which seems to be for
    human use.  Consider putting them in separate packages.

12) There is no man page for bdump.

13) There is a '%' sign in %description; doubling it ("%%") produces the
    correct output and avoids confusing rpm.

14) There is no stated justification for the patch.  Anyway, it isn't needed.
    Drop the patch and do this in %install instead:

export PREFIX=$RPM_BUILD_ROOT%{_prefix}
export OCAMLFIND_DESTDIR=$RPM_BUILD_ROOT%{_libdir}/ocaml
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $OCAMLFIND_DESTDIR
make install


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 17 files have unknown license. Detailed output of
     licensecheck in /home/jamesjer/1055393-ocaml-biniou/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Macros in Summary, %description expandable at SRPM build time.
     Note: Macros in: ocaml-biniou (description)
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[!]: Useful -debuginfo package or justification otherwise.
[!]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Ocaml:
[x]: This should never happen

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in ocaml-
     biniou-devel
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[!]: Spec use %global instead of %define unless justified.
     Note: %define requiring justification: %define libname %(echo %{name} |
     sed -e 's/^ocaml-//')
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ocaml-biniou-1.0.9-1.fc21.x86_64.rpm
          ocaml-biniou-devel-1.0.9-1.fc21.x86_64.rpm
          ocaml-biniou-1.0.9-1.fc21.src.rpm
ocaml-biniou.x86_64: W: spelling-error %description -l en_US yojson -> Jayson
ocaml-biniou.x86_64: W: spelling-error %description -l en_US atdgen -> attend
ocaml-biniou.x86_64: W: spelling-error %description -l en_US serializers -> serializes, serialize rs, serialize-rs
ocaml-biniou.x86_64: W: spelling-error %description -l en_US deserializers -> serializes, depersonalizes, materializes
ocaml-biniou.x86_64: W: no-manual-page-for-binary bdump
ocaml-biniou.src: W: spelling-error %description -l en_US yojson -> Jayson
ocaml-biniou.src: W: spelling-error %description -l en_US bdump -> bump, dump, b dump
ocaml-biniou.src: W: spelling-error %description -l en_US atdgen -> attend
ocaml-biniou.src: W: spelling-error %description -l en_US serializers -> serializes, serialize rs, serialize-rs
ocaml-biniou.src: W: spelling-error %description -l en_US deserializers -> serializes, depersonalizes, materializes
3 packages and 0 specfiles checked; 0 errors, 10 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint ocaml-biniou ocaml-biniou-devel
ocaml-biniou.x86_64: W: spelling-error %description -l en_US yojson -> Jayson
ocaml-biniou.x86_64: W: spelling-error %description -l en_US atdgen -> attend
ocaml-biniou.x86_64: W: spelling-error %description -l en_US serializers -> serializes, serialize rs, serialize-rs
ocaml-biniou.x86_64: W: spelling-error %description -l en_US deserializers -> serializes, depersonalizes, materializes
ocaml-biniou.x86_64: W: no-manual-page-for-binary bdump
2 packages and 0 specfiles checked; 0 errors, 5 warnings.
# echo 'rpmlint-done:'



Requires
--------
ocaml-biniou (rpmlib, GLIBC filtered):
    ocaml(Array)
    ocaml(Buffer)
    ocaml(CamlinternalLazy)
    ocaml(Char)
    ocaml(Easy_format)
    ocaml(Filename)
    ocaml(Format)
    ocaml(Hashtbl)
    ocaml(Int32)
    ocaml(Int64)
    ocaml(Lazy)
    ocaml(List)
    ocaml(Obj)
    ocaml(Pervasives)
    ocaml(Printexc)
    ocaml(Printf)
    ocaml(Stream)
    ocaml(String)
    ocaml(Sys)
    ocaml(runtime)

ocaml-biniou-devel (rpmlib, GLIBC filtered):
    ocaml-biniou



Provides
--------
ocaml-biniou:
    ocaml(Bi_dump)
    ocaml(Bi_inbuf)
    ocaml(Bi_io)
    ocaml(Bi_outbuf)
    ocaml(Bi_share)
    ocaml(Bi_stream)
    ocaml(Bi_util)
    ocaml(Bi_vint)
    ocaml-biniou
    ocaml-biniou(x86-64)

ocaml-biniou-devel:
    ocaml-biniou-devel
    ocaml-biniou-devel(x86-64)



Source checksums
----------------
http://mjambon.com/releases/biniou/biniou-1.0.9.tar.gz :
  CHECKSUM(SHA256) this package     : eb47c48f61b169e652629e7f2ee582dfd5965e640ee51bf28fab63b960864392
  CHECKSUM(SHA256) upstream package : eb47c48f61b169e652629e7f2ee582dfd5965e640ee51bf28fab63b960864392


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1055393 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Ocaml, C/C++
Disabled plugins: Java, Python, SugarActivity, fonts, Haskell, Perl, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 3 Michel Alexandre Salim 2014-01-23 07:43:44 UTC
Incorporated review feedbacks in -2, links and comments below.

Spec URL: http://salimma.fedorapeople.org/specs/ocaml/ocaml-biniou.spec
SRPM URL: http://salimma.fedorapeople.org/specs/ocaml/ocaml-biniou-1.0.9-2.fc20.src.rpm

(In reply to Jerry James from comment #2)
> The first nine issues are repeats from the ocaml-easy-format review, because
> they apply to this package as well:
> 
[snip -- fixed as in ocaml-easy-format]
> 7) Move %define libname down farther (between Summary and License?) and make
>    it %global instead.  Oh, and here's a trick that lets you invoke 1
>    subprocess instead of two:
> 
>    %global libname %(sed -e 's/^ocaml-//' <<< %{name})
> 
Oh, that is neat indeed! Already spun a new srpm so that will go in at the next revision

> 8) If possible, avoid building the bytecode version on platforms that can
>    build the binary version; in this case, I see this in the build log after
>    building the binary version:
> 
>    + make opt
>    make: Nothing to be done for `opt'.
> 
>    because the default target builds both the bytecode and binary versions.
> 
I've decomposed the 'default' build target to compensate, see revised spec

> 9) Consider adding a %check script; "make test" appears to work for me.
> 
the default target originally ran the test target as well, it's now moved to %check

> 10) The description mentions a binary "atdgen", but there is no such binary
> in
>     any of the binary RPMs.
> 
Yanked

> 11) I'm concerned about the binary named "bdump".  First, that's a pretty
>     generic name.  It doesn't collide with anything currently in Fedora, but
>     I'm concerned that it may in the future.  Also, I'm not certain that
> bdump
>     and the libraries should both go into the main package.  Programs that
>     link against the library probably won't need bdump, which seems to be for
>     human use.  Consider putting them in separate packages.
> 
Good point. I've moved it to the -devel subpackage (and prefixed it with ocaml-), and as it turns out it's only generated when ocamlopt is available so now it's within the %if guard

> 12) There is no man page for bdump.
> 
Yes, upstream doesn't seem to provide one

> 13) There is a '%' sign in %description; doubling it ("%%") produces the
>     correct output and avoids confusing rpm.
> 
Fixed

> 14) There is no stated justification for the patch.  Anyway, it isn't needed.
>     Drop the patch and do this in %install instead:
> 
Aha, good point

Comment 4 Jerry James 2014-01-23 16:37:56 UTC
(In reply to Michel Alexandre Salim from comment #3)
> Incorporated review feedbacks in -2, links and comments below.

#6 appears to have been missed:

6) Remove rm -rf $RPM_BUILD_ROOT from the top of %install.

But that's not a big deal.  Take care of it when you import the package.
 
> > 12) There is no man page for bdump.
> > 
> Yes, upstream doesn't seem to provide one

That's a SHOULD item, so does not block the review.

I see no further issues, so this package is APPROVED.

Comment 5 Michel Alexandre Salim 2014-01-24 07:01:58 UTC
(In reply to Jerry James from comment #4)
> (In reply to Michel Alexandre Salim from comment #3)
> > Incorporated review feedbacks in -2, links and comments below.
> 
> #6 appears to have been missed:
> 
> 6) Remove rm -rf $RPM_BUILD_ROOT from the top of %install.
> 
Ah yes. Will fix when importing.
> 
> I see no further issues, so this package is APPROVED.

Thanks!

New Package SCM Request
=======================
Package Name: ocaml-biniou
Short Description: Safe and fast binary data format
Owners: salimma
Branches: f19 f20
InitialCC:

Comment 6 Gwyn Ciesla 2014-01-24 12:45:38 UTC
Git done (by process-git-requests).

Comment 7 Fedora Update System 2014-01-26 12:57:51 UTC
ocaml-biniou-1.0.9-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ocaml-biniou-1.0.9-2.fc19

Comment 8 Fedora Update System 2014-01-26 12:57:59 UTC
ocaml-biniou-1.0.9-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/ocaml-biniou-1.0.9-2.fc20

Comment 9 Fedora Update System 2014-01-27 13:07:23 UTC
ocaml-biniou-1.0.9-2.fc19 has been pushed to the Fedora 19 testing repository.

Comment 10 Fedora Update System 2014-02-06 03:48:25 UTC
ocaml-biniou-1.0.9-2.fc20 has been pushed to the Fedora 20 stable repository.

Comment 11 Fedora Update System 2014-02-06 03:51:07 UTC
ocaml-biniou-1.0.9-2.fc19 has been pushed to the Fedora 19 stable repository.


Note You need to log in before you can comment on or make changes to this bug.